
#include <iodef.h>
#include <mylib.h>
#include <portable.h>

VOID tim_on(VOID)
{
  UCHAR c = IN_PORT(0x61);
  c |= 1;
  OUT_PORT(0x61,c);
}

VOID tim_off(VOID)
{
  UCHAR c = IN_PORT(0x61);
  c &= ~1;
  OUT_PORT(0x61,c);
}

VOID tim_wait(UINT time)
{
  UCHAR h;

  tim_on();
  OUT_PORT(PC_TIM|TIM_CTL,0xb6);
  OUT_PORT(PC_TIM|TIM_CH2,0x00); /* Zeitkonstante niederwertiger Teil */
  OUT_PORT(PC_TIM|TIM_CH2,0xff); /* Zeitkonstante hherwertiger Teil */
  do
  {
    do
    {
      h=IN_PORT(PC_TIM|TIM_CH2); /* niederwerigen Teil lesen und verwerfen */
      h=IN_PORT(PC_TIM|TIM_CH2);
    }
    while (h);
  }
  while (time--);
  tim_off();
}

VOID tim_init(VOID)
{
  OUT_PORT(PC_TIM|TIM_CTL,0xb6);
  OUT_PORT(PC_TIM|TIM_CH2,0x33); /* Zeitkonstante niederwertiger Teil */
  OUT_PORT(PC_TIM|TIM_CH2,0x05); /* Zeitkonstante hherwertiger Teil */
}

VOID tim_set(UINT count)
{
  OUT_PORT(PC_TIM|TIM_CTL,0xb6);
  OUT_PORT(PC_TIM|TIM_CH2,(UCHAR)count);      /* niederwertiger Teil */
  OUT_PORT(PC_TIM|TIM_CH2,(UCHAR)(count>>8)); /* hherwertiger Teil */
}

VOID tim0_set(UINT count)
{
  OUT_PORT(PC_TIM|TIM_CTL,0x36);
  OUT_PORT(PC_TIM|TIM_CH0,(UCHAR)count);      /* niederwertiger Teil */
  OUT_PORT(PC_TIM|TIM_CH0,(UCHAR)(count>>8)); /* hherwertiger Teil */
}

UINT tim0_read(VOID)
{
  UINT h,l;
  l=IN_PORT(PC_TIM|TIM_CH0);
  h=IN_PORT(PC_TIM|TIM_CH0);
  return ((h<<8)+l);
}
